/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/* --- BBS: www.STCAIMCU.com  -----------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ            */
/*---------------------------------------------------------------------*/

#ifndef	__STC8G_PCA_H
#define	__STC8G_PCA_H

#include	"config.h"

//========================================================================
//                              Ĵλ
//========================================================================

sfr CCON   = 0xD8;	//
sfr CMOD   = 0xD9;	//
sfr CCAPM0 = 0xDA;	//PCAģ0ĹģʽĴ
sfr CCAPM1 = 0xDB;	//PCAģ1ĹģʽĴ
sfr CCAPM2 = 0xDC;	//PCAģ2ĹģʽĴ

sfr CL     = 0xE9;	//
sfr CCAP0L = 0xEA;	//PCAģ0Ĳ׽/ȽϼĴ8λ
sfr CCAP1L = 0xEB;	//PCAģ1Ĳ׽/ȽϼĴ8λ
sfr CCAP2L = 0xEC;	//PCAģ2Ĳ׽/ȽϼĴ8λ

sfr PCA_PWM0 = 0xF2;	//PCAģ0 PWMĴ
sfr PCA_PWM1 = 0xF3;	//PCAģ1 PWMĴ
sfr PCA_PWM2 = 0xF4;	//PCAģ2 PWMĴ

sfr CH     = 0xF9;
sfr CCAP0H = 0xFA;		//PCAģ0Ĳ׽/ȽϼĴ8λ
sfr CCAP1H = 0xFB;		//PCAģ1Ĳ׽/ȽϼĴ8λ
sfr CCAP2H = 0xFC;		//PCAģ2Ĳ׽/ȽϼĴ8λ

//						7     6     5     4     3     2     1     0     Reset Value
//sfr CCON   = 0xD8;	CF    CR    -     -    CCF3  CCF2  CCF1  CCF0   00xx,xx00	//PCA ƼĴ
sbit CCF0  = CCON^0;	/* PCA ģ0жϱ־Ӳλ0	*/
sbit CCF1  = CCON^1;	/* PCA ģ1жϱ־Ӳλ0	*/
sbit CCF2  = CCON^2;	/* PCA ģ2жϱ־Ӳλ0	*/
//sbit CCF3  = CCON^3;	/* PCA ģ3жϱ־Ӳλ0	*/
sbit CR    = CCON^6;	/* 1: PCA0*/
sbit CF    = CCON^7;	/* PCACHCLFFFFHΪ0000H־PCAӲλ0*/

//========================================================================
//                              
//========================================================================

#define PCA_VECTOR		7

#define	PCA0			0
#define	PCA1			1
#define	PCA2			2
#define	PCA_Counter		3

#define	PCA_Clock_1T	(4<<1)
#define	PCA_Clock_2T	(1<<1)
#define	PCA_Clock_4T	(5<<1)
#define	PCA_Clock_6T	(6<<1)
#define	PCA_Clock_8T	(7<<1)
#define	PCA_Clock_12T	(0<<1)
#define	PCA_Clock_Timer0_OF	(2<<1)
#define	PCA_Clock_ECI	(3<<1)

#define	PCA_Rise_Active	(1<<5)
#define	PCA_Fall_Active	(1<<4)

#define	PCA_PWM_8bit	(0<<6)
#define	PCA_PWM_7bit	(1<<6)
#define	PCA_PWM_6bit	(2<<6)
#define	PCA_PWM_10bit	(3<<6)

//---------------------------------------------------------

#define	PCA_ECOM			(1<<6)	//PCAģıȽϹ
#define	PCA_CCAPP			(1<<5)	//PCAģز
#define	PCA_CCAPN			(1<<4)	//PCAģ½ز
#define	PCA_MAT				(1<<3)	//PCAģƥ书
#define	PCA_TOG				(1<<2)	//PCAģĸ
#define	PCA_PWM				(1<<1)	//PCAģ
#define	PCA_ECCF			(1<<0)	//PCAģƥ/ж

#define	PCA_Mode_PWM				0x42	//B0100_0010
#define	PCA_Mode_Capture			0x11	//B0001_0001
#define	PCA_Mode_SoftTimer			0x48	//B0100_1000
#define	PCA_Mode_HighPulseOutput	0x4d	//B0100_1101

//---------------------------------------------------------

//                                           7      6      5      4      3      2      1      0      Reset Value
//sfr IPH   = 0xB7; //жȼλ       PPCAH  PLVDH   PADCH   PSH   PT1H    PX1H   PT0H   PX0H    0000,0000
#define		PPCAH	0x80

//CCP/PCA/PWMжȼ
#define 	PCA_Priority(n)				do{if(n == 0) IPH &= ~PPCAH, PPCA = 0; \
																if(n == 1) IPH &= ~PPCAH, PPCA = 1; \
																if(n == 2) IPH |= PPCAH, PPCA = 0; \
																if(n == 3) IPH |= PPCAH, PPCA = 1; \
															}while(0)

//---------------------------------------------------------

typedef struct
{
	u8	PCA_Clock;		//PCA_Clock_1T, PCA_Clock_2T, PCA_Clock_4T, PCA_Clock_6T, PCA_Clock_8T, PCA_Clock_12T, PCA_Clock_Timer0_OF, PCA_Clock_ECI
	u8	PCA_PWM_Wide;	//PCA_PWM_8bit, PCA_PWM_7bit, PCA_PWM_6bit, PCA_PWM_10bit
	u16	PCA_Value;
	u8	PCA_RUN;			//ENABLE, DISABLE
} PCA_InitTypeDef;

extern	bit		B_Capture0,B_Capture1,B_Capture2;
extern	u8		PCA0_mode,PCA1_mode,PCA2_mode;
extern	u16		CCAP0_tmp,PCA_Timer0;
extern	u16		CCAP1_tmp,PCA_Timer1;
extern	u16		CCAP2_tmp,PCA_Timer2;

void PCA_Init(u8 PCA_id, PCA_InitTypeDef *PCAx);
void UpdatePcaPwm(u8 PCA_id, u16 pwm_value);
u8 NVIC_PCA_Init(u8 Channel, u8 State, u8 Priority);

#endif

